+++
title = "Icosahedron"
+++

### FormFactorIcosahedron

A regular icosahedron.


<img src="../3d/Icosahedron.png" width="30%">
<!--
<img src="../cut/Icosahedron_xy.svg" width="30%">
<img src="../cut/Icosahedron_xz.svg" width="30%">
-->

#### Constructor

{{< highlight python >}}
FormFactorIcosahedron(a)
{{< /highlight >}}

Parameters:
- a, length of the edge

#### Usage

As for any other [Form factor](/py/sample/particle/ff).

#### Implementation

Class {{% ref-class "Sample/HardParticle" "FormFactorIcosahedron" %}} inherits from the interface class
{{% ref-class "Sample/Particle" "IFormFactor" %}}.

Form factor computation is based on the generic form factor of a polyhedron with inversion symmetry provided by [libformfactor](https://jugit.fz-juelich.de/mlz/libformfactor).

Volume [has been validated]({{% url-src %}}/Tests/Unit/Sample/FormFactorBasicTest.cpp)
against
$$ V= \dfrac{5}{12}(3+\sqrt{5})a^3 \approx 2.182 \space a^3. $$

#### Related shapes

- [Dodecahedron](/py/sample/particle/ff/hard/dodecahedron), a regular dodecahedron. 

#### Example

Scattering by uncorrelated, oriented truncated icosahedra for horizontal incidence:

<img src="/img/auto/ff/Icosahedron.png">

Generated by {{% ref-src "Examples/ff/Icosahedron.py" %}}.

#### History

Introduced in BornAgain 1.6.
