+++
title = "Simulations"
weight = 15
+++

## Basic simulation types

To prepare and run a BornAgain simulation, one needs to create an instance of
one a `Simulation` class. This class is then populated with information
about the scattering target ("sample") and about the simulated instrument
(beam and detector).

Here is one example for each basic type of simulation:

* [Reflectometry]({{% ref-py "simulation/reflectometry/_index.md" %}})
* [Off-specular scattering]({{% ref-py "simulation/offspec" %}})
* [Grazing-incidence small-angle scattering (GISAS)]({{%
  ref-py "simulation/gisas" %}})
* [Small-angle scattering (SAS)]({{% ref-py "simulation/sas" %}})
* [Depth-probe]({{% ref-py "simulation/depth-probe" %}})

Explanations that apply to all types of simulation are given only once,
namely in the [reflectometry]({{% ref-py "simulation/reflectometry/_index.md" %}}) chapter.
